require "player"
require "ball"

function love.load()
--Game Vars
	love.graphics.setBackgroundColor(0,0,0)
	gwidth = 1280
	gheight = 720
--Environment Vars
	gravity = 800
--Loading functions
	player1.load()
	player2.load()
end

function love.draw()
	player1.draw()
	player2.draw()
	ball.draw()
	love.graphics.setColor(255,255,255)
	love.graphics.print(ball.count,0,0)
	love.graphics.print("Press space to spawn a 'ball'",0,10)
		for i,v in ipairs(ball) do
		love.graphics.print(v.dir,0,20)
	end
end

function love.update(dt)
	player1.update(dt)
	player2.update(dt)
	ball.update(dt)
	paddle_hit()
	player_bounds()
	ball_bounds()
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
	if key == " " and ball.count > 0 then
		ball.spawn()
	end
end

function paddle_hit()
	for i,v in ipairs(ball) do
		if Collision(player1.x,player1.y,player1.width,player1.height, v.x,v.y,v.width,v.height) then
			ball.xVel = -1 * ball.xVel - math.random(700,800)
			ball.yVel = -1 * ball.yVel - math.random(1200,1300)
			v.dir = "left"
		elseif Collision(player2.x,player2.y,player2.width,player2.height, v.x,v.y,v.width,v.height) then
			ball.xVel = -1 * ball.xVel + math.random(700,800)
			ball.yVel = -1 * ball.yVel - math.random(1200,1300)
			v.dir = "right"
		end
	end
end

function player_bounds()
--Left Side
	if player1.x <= 0 then
		player1.x = 0
	end
	if player2.x <= 100 then
		player2.x = 100
	end
--Right Side
	if player2.x >= 1180 then
		player2.x = 1180
	end
	if player1.x >= 1080 then
		player1.x = 1080
	end
end

function ball_bounds()
	for i,v in ipairs(ball) do
		if v.x >= 1260 then
			v.x = 1260
			ball.xVel = -1 * ball.xVel
		end
		if v.x <= 0 then
			v.x = 0
			ball.xVel = -1 * ball.xVel
		end
		if v.y <= 0 and v.dir == "left" then
			v.y = 0
			ball.yVel = -1 * ball.yVel
			ball.xVel = 1 * ball.xVel
			v.dir = "right"
		elseif v.y <= 0 and v.dir == "right" then
			v.y = 0
			ball.yVel = -1 * ball.yVel
			ball.xVel = 1 * ball.xVel
			v.dir = "left"
		end
	end
end
	

function Collision(x1,y1,w1,h1, x2,y2,w2,h2)
	return x1 < x2+w2 and
		x2 <x1+w1 and
		y1 < y2+h2 and
		y2 < y1+h1
end